git-rebase.shon commit Merge branch 'tz/do-not-clean-spec-file' (0996727)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6SUBDIRECTORY_OK=Yes
   7OPTIONS_KEEPDASHDASH=
   8OPTIONS_STUCKLONG=t
   9OPTIONS_SPEC="\
  10git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] [<upstream>] [<branch>]
  11git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] --root [<branch>]
  12git rebase --continue | --abort | --skip | --edit-todo
  13--
  14 Available options are
  15v,verbose!         display a diffstat of what changed upstream
  16q,quiet!           be quiet. implies --no-stat
  17autostash          automatically stash/stash pop before and after
  18fork-point         use 'merge-base --fork-point' to refine upstream
  19onto=!             rebase onto given branch instead of upstream
  20p,preserve-merges! try to recreate merges instead of ignoring them
  21s,strategy=!       use the given merge strategy
  22no-ff!             cherry-pick all commits, even if unchanged
  23m,merge!           use merging strategies to rebase
  24i,interactive!     let the user edit the list of commits to rebase
  25x,exec=!           add exec lines after each commit of the editable list
  26k,keep-empty       preserve empty commits during rebase
  27allow-empty-message allow rebasing commits with empty messages
  28f,force-rebase!    force rebase even if branch is up to date
  29X,strategy-option=! pass the argument through to the merge strategy
  30stat!              display a diffstat of what changed upstream
  31n,no-stat!         do not show diffstat of what changed upstream
  32verify             allow pre-rebase hook to run
  33rerere-autoupdate  allow rerere to update index with resolved conflicts
  34root!              rebase all reachable commits up to the root(s)
  35autosquash         move commits that begin with squash!/fixup! under -i
  36committer-date-is-author-date! passed to 'git am'
  37ignore-date!       passed to 'git am'
  38signoff            passed to 'git am'
  39whitespace=!       passed to 'git apply'
  40ignore-whitespace! passed to 'git apply'
  41C=!                passed to 'git apply'
  42S,gpg-sign?        GPG-sign commits
  43 Actions:
  44continue!          continue
  45abort!             abort and check out the original branch
  46skip!              skip current patch and continue
  47edit-todo!         edit the todo list during an interactive rebase
  48quit!              abort but keep HEAD where it is
  49"
  50. git-sh-setup
  51set_reflog_action rebase
  52require_work_tree_exists
  53cd_to_toplevel
  54
  55LF='
  56'
  57ok_to_skip_pre_rebase=
  58resolvemsg="
  59$(gettext 'Resolve all conflicts manually, mark them as resolved with
  60"git add/rm <conflicted_files>", then run "git rebase --continue".
  61You can instead skip this commit: run "git rebase --skip".
  62To abort and get back to the state before "git rebase", run "git rebase --abort".')
  63"
  64unset onto
  65unset restrict_revision
  66cmd=
  67strategy=
  68strategy_opts=
  69do_merge=
  70merge_dir="$GIT_DIR"/rebase-merge
  71apply_dir="$GIT_DIR"/rebase-apply
  72verbose=
  73diffstat=
  74test "$(git config --bool rebase.stat)" = true && diffstat=t
  75autostash="$(git config --bool rebase.autostash || echo false)"
  76fork_point=auto
  77git_am_opt=
  78git_format_patch_opt=
  79rebase_root=
  80force_rebase=
  81allow_rerere_autoupdate=
  82# Non-empty if a rebase was in progress when 'git rebase' was invoked
  83in_progress=
  84# One of {am, merge, interactive}
  85type=
  86# One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
  87state_dir=
  88# One of {'', continue, skip, abort}, as parsed from command line
  89action=
  90preserve_merges=
  91autosquash=
  92keep_empty=
  93allow_empty_message=
  94test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
  95case "$(git config --bool commit.gpgsign)" in
  96true)   gpg_sign_opt=-S ;;
  97*)      gpg_sign_opt= ;;
  98esac
  99
 100read_basic_state () {
 101        test -f "$state_dir/head-name" &&
 102        test -f "$state_dir/onto" &&
 103        head_name=$(cat "$state_dir"/head-name) &&
 104        onto=$(cat "$state_dir"/onto) &&
 105        # We always write to orig-head, but interactive rebase used to write to
 106        # head. Fall back to reading from head to cover for the case that the
 107        # user upgraded git with an ongoing interactive rebase.
 108        if test -f "$state_dir"/orig-head
 109        then
 110                orig_head=$(cat "$state_dir"/orig-head)
 111        else
 112                orig_head=$(cat "$state_dir"/head)
 113        fi &&
 114        GIT_QUIET=$(cat "$state_dir"/quiet) &&
 115        test -f "$state_dir"/verbose && verbose=t
 116        test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
 117        test -f "$state_dir"/strategy_opts &&
 118                strategy_opts="$(cat "$state_dir"/strategy_opts)"
 119        test -f "$state_dir"/allow_rerere_autoupdate &&
 120                allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
 121        test -f "$state_dir"/gpg_sign_opt &&
 122                gpg_sign_opt="$(cat "$state_dir"/gpg_sign_opt)"
 123}
 124
 125write_basic_state () {
 126        echo "$head_name" > "$state_dir"/head-name &&
 127        echo "$onto" > "$state_dir"/onto &&
 128        echo "$orig_head" > "$state_dir"/orig-head &&
 129        echo "$GIT_QUIET" > "$state_dir"/quiet &&
 130        test t = "$verbose" && : > "$state_dir"/verbose
 131        test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
 132        test -n "$strategy_opts" && echo "$strategy_opts" > \
 133                "$state_dir"/strategy_opts
 134        test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
 135                "$state_dir"/allow_rerere_autoupdate
 136        test -n "$gpg_sign_opt" && echo "$gpg_sign_opt" > "$state_dir"/gpg_sign_opt
 137}
 138
 139output () {
 140        case "$verbose" in
 141        '')
 142                output=$("$@" 2>&1 )
 143                status=$?
 144                test $status != 0 && printf "%s\n" "$output"
 145                return $status
 146                ;;
 147        *)
 148                "$@"
 149                ;;
 150        esac
 151}
 152
 153move_to_original_branch () {
 154        case "$head_name" in
 155        refs/*)
 156                message="rebase finished: $head_name onto $onto"
 157                git update-ref -m "$message" \
 158                        $head_name $(git rev-parse HEAD) $orig_head &&
 159                git symbolic-ref \
 160                        -m "rebase finished: returning to $head_name" \
 161                        HEAD $head_name ||
 162                die "$(eval_gettext "Could not move back to \$head_name")"
 163                ;;
 164        esac
 165}
 166
 167apply_autostash () {
 168        if test -f "$state_dir/autostash"
 169        then
 170                stash_sha1=$(cat "$state_dir/autostash")
 171                if git stash apply $stash_sha1 >/dev/null 2>&1
 172                then
 173                        echo "$(gettext 'Applied autostash.')" >&2
 174                else
 175                        git stash store -m "autostash" -q $stash_sha1 ||
 176                        die "$(eval_gettext "Cannot store \$stash_sha1")"
 177                        gettext 'Applying autostash resulted in conflicts.
 178Your changes are safe in the stash.
 179You can run "git stash pop" or "git stash drop" at any time.
 180' >&2
 181                fi
 182        fi
 183}
 184
 185finish_rebase () {
 186        apply_autostash &&
 187        { git gc --auto || true; } &&
 188        rm -rf "$state_dir"
 189}
 190
 191run_specific_rebase () {
 192        if [ "$interactive_rebase" = implied ]; then
 193                GIT_EDITOR=:
 194                export GIT_EDITOR
 195                autosquash=
 196        fi
 197        . git-rebase--$type
 198        ret=$?
 199        if test $ret -eq 0
 200        then
 201                finish_rebase
 202        elif test $ret -eq 2 # special exit status for rebase -i
 203        then
 204                apply_autostash &&
 205                rm -rf "$state_dir" &&
 206                die "Nothing to do"
 207        fi
 208        exit $ret
 209}
 210
 211run_pre_rebase_hook () {
 212        if test -z "$ok_to_skip_pre_rebase" &&
 213           test -x "$(git rev-parse --git-path hooks/pre-rebase)"
 214        then
 215                "$(git rev-parse --git-path hooks/pre-rebase)" ${1+"$@"} ||
 216                die "$(gettext "The pre-rebase hook refused to rebase.")"
 217        fi
 218}
 219
 220test -f "$apply_dir"/applying &&
 221        die "$(gettext "It looks like 'git am' is in progress. Cannot rebase.")"
 222
 223if test -d "$apply_dir"
 224then
 225        type=am
 226        state_dir="$apply_dir"
 227elif test -d "$merge_dir"
 228then
 229        if test -f "$merge_dir"/interactive
 230        then
 231                type=interactive
 232                interactive_rebase=explicit
 233        else
 234                type=merge
 235        fi
 236        state_dir="$merge_dir"
 237fi
 238test -n "$type" && in_progress=t
 239
 240total_argc=$#
 241while test $# != 0
 242do
 243        case "$1" in
 244        --no-verify)
 245                ok_to_skip_pre_rebase=yes
 246                ;;
 247        --verify)
 248                ok_to_skip_pre_rebase=
 249                ;;
 250        --continue|--skip|--abort|--quit|--edit-todo)
 251                test $total_argc -eq 2 || usage
 252                action=${1##--}
 253                ;;
 254        --onto=*)
 255                onto="${1#--onto=}"
 256                ;;
 257        --exec=*)
 258                cmd="${cmd}exec ${1#--exec=}${LF}"
 259                test -z "$interactive_rebase" && interactive_rebase=implied
 260                ;;
 261        --interactive)
 262                interactive_rebase=explicit
 263                ;;
 264        --keep-empty)
 265                keep_empty=yes
 266                ;;
 267        --allow-empty-message)
 268                allow_empty_message=--allow-empty-message
 269                ;;
 270        --preserve-merges)
 271                preserve_merges=t
 272                test -z "$interactive_rebase" && interactive_rebase=implied
 273                ;;
 274        --autosquash)
 275                autosquash=t
 276                ;;
 277        --no-autosquash)
 278                autosquash=
 279                ;;
 280        --fork-point)
 281                fork_point=t
 282                ;;
 283        --no-fork-point)
 284                fork_point=
 285                ;;
 286        --merge)
 287                do_merge=t
 288                ;;
 289        --strategy-option=*)
 290                strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--${1#--strategy-option=}")"
 291                do_merge=t
 292                test -z "$strategy" && strategy=recursive
 293                ;;
 294        --strategy=*)
 295                strategy="${1#--strategy=}"
 296                do_merge=t
 297                ;;
 298        --no-stat)
 299                diffstat=
 300                ;;
 301        --stat)
 302                diffstat=t
 303                ;;
 304        --autostash)
 305                autostash=true
 306                ;;
 307        --no-autostash)
 308                autostash=false
 309                ;;
 310        --verbose)
 311                verbose=t
 312                diffstat=t
 313                GIT_QUIET=
 314                ;;
 315        --quiet)
 316                GIT_QUIET=t
 317                git_am_opt="$git_am_opt -q"
 318                verbose=
 319                diffstat=
 320                ;;
 321        --whitespace=*)
 322                git_am_opt="$git_am_opt --whitespace=${1#--whitespace=}"
 323                case "${1#--whitespace=}" in
 324                fix|strip)
 325                        force_rebase=t
 326                        ;;
 327                esac
 328                ;;
 329        --ignore-whitespace)
 330                git_am_opt="$git_am_opt $1"
 331                ;;
 332        --committer-date-is-author-date|--ignore-date|--signoff|--no-signoff)
 333                git_am_opt="$git_am_opt $1"
 334                force_rebase=t
 335                ;;
 336        -C*)
 337                git_am_opt="$git_am_opt $1"
 338                ;;
 339        --root)
 340                rebase_root=t
 341                ;;
 342        --force-rebase|--no-ff)
 343                force_rebase=t
 344                ;;
 345        --rerere-autoupdate|--no-rerere-autoupdate)
 346                allow_rerere_autoupdate="$1"
 347                ;;
 348        --gpg-sign)
 349                gpg_sign_opt=-S
 350                ;;
 351        --gpg-sign=*)
 352                gpg_sign_opt="-S${1#--gpg-sign=}"
 353                ;;
 354        --)
 355                shift
 356                break
 357                ;;
 358        *)
 359                usage
 360                ;;
 361        esac
 362        shift
 363done
 364test $# -gt 2 && usage
 365
 366if test -n "$action"
 367then
 368        test -z "$in_progress" && die "$(gettext "No rebase in progress?")"
 369        # Only interactive rebase uses detailed reflog messages
 370        if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
 371        then
 372                GIT_REFLOG_ACTION="rebase -i ($action)"
 373                export GIT_REFLOG_ACTION
 374        fi
 375fi
 376
 377if test "$action" = "edit-todo" && test "$type" != "interactive"
 378then
 379        die "$(gettext "The --edit-todo action can only be used during interactive rebase.")"
 380fi
 381
 382case "$action" in
 383continue)
 384        # Sanity check
 385        git rev-parse --verify HEAD >/dev/null ||
 386                die "$(gettext "Cannot read HEAD")"
 387        git update-index --ignore-submodules --refresh &&
 388        git diff-files --quiet --ignore-submodules || {
 389                echo "$(gettext "You must edit all merge conflicts and then
 390mark them as resolved using git add")"
 391                exit 1
 392        }
 393        read_basic_state
 394        run_specific_rebase
 395        ;;
 396skip)
 397        output git reset --hard HEAD || exit $?
 398        read_basic_state
 399        run_specific_rebase
 400        ;;
 401abort)
 402        git rerere clear
 403        read_basic_state
 404        case "$head_name" in
 405        refs/*)
 406                git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
 407                die "$(eval_gettext "Could not move back to \$head_name")"
 408                ;;
 409        esac
 410        output git reset --hard $orig_head
 411        finish_rebase
 412        exit
 413        ;;
 414quit)
 415        exec rm -rf "$state_dir"
 416        ;;
 417edit-todo)
 418        run_specific_rebase
 419        ;;
 420esac
 421
 422# Make sure no rebase is in progress
 423if test -n "$in_progress"
 424then
 425        state_dir_base=${state_dir##*/}
 426        cmd_live_rebase="git rebase (--continue | --abort | --skip)"
 427        cmd_clear_stale_rebase="rm -fr \"$state_dir\""
 428        die "
 429$(eval_gettext 'It seems that there is already a $state_dir_base directory, and
 430I wonder if you are in the middle of another rebase.  If that is the
 431case, please try
 432        $cmd_live_rebase
 433If that is not the case, please
 434        $cmd_clear_stale_rebase
 435and run me again.  I am stopping in case you still have something
 436valuable there.')"
 437fi
 438
 439if test -n "$rebase_root" && test -z "$onto"
 440then
 441        test -z "$interactive_rebase" && interactive_rebase=implied
 442fi
 443
 444if test -n "$interactive_rebase"
 445then
 446        type=interactive
 447        state_dir="$merge_dir"
 448elif test -n "$do_merge"
 449then
 450        type=merge
 451        state_dir="$merge_dir"
 452else
 453        type=am
 454        state_dir="$apply_dir"
 455fi
 456
 457if test -t 2 && test -z "$GIT_QUIET"
 458then
 459        git_format_patch_opt="$git_format_patch_opt --progress"
 460fi
 461
 462if test -z "$rebase_root"
 463then
 464        case "$#" in
 465        0)
 466                if ! upstream_name=$(git rev-parse --symbolic-full-name \
 467                        --verify -q @{upstream} 2>/dev/null)
 468                then
 469                        . git-parse-remote
 470                        error_on_missing_default_upstream "rebase" "rebase" \
 471                                "against" "git rebase $(gettext '<branch>')"
 472                fi
 473
 474                test "$fork_point" = auto && fork_point=t
 475                ;;
 476        *)      upstream_name="$1"
 477                if test "$upstream_name" = "-"
 478                then
 479                        upstream_name="@{-1}"
 480                fi
 481                shift
 482                ;;
 483        esac
 484        upstream=$(peel_committish "${upstream_name}") ||
 485        die "$(eval_gettext "invalid upstream '\$upstream_name'")"
 486        upstream_arg="$upstream_name"
 487else
 488        if test -z "$onto"
 489        then
 490                empty_tree=$(git hash-object -t tree /dev/null)
 491                onto=$(git commit-tree $empty_tree </dev/null)
 492                squash_onto="$onto"
 493        fi
 494        unset upstream_name
 495        unset upstream
 496        test $# -gt 1 && usage
 497        upstream_arg=--root
 498fi
 499
 500# Make sure the branch to rebase onto is valid.
 501onto_name=${onto-"$upstream_name"}
 502case "$onto_name" in
 503*...*)
 504        if      left=${onto_name%...*} right=${onto_name#*...} &&
 505                onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
 506        then
 507                case "$onto" in
 508                ?*"$LF"?*)
 509                        die "$(eval_gettext "\$onto_name: there are more than one merge bases")"
 510                        ;;
 511                '')
 512                        die "$(eval_gettext "\$onto_name: there is no merge base")"
 513                        ;;
 514                esac
 515        else
 516                die "$(eval_gettext "\$onto_name: there is no merge base")"
 517        fi
 518        ;;
 519*)
 520        onto=$(peel_committish "$onto_name") ||
 521        die "$(eval_gettext "Does not point to a valid commit: \$onto_name")"
 522        ;;
 523esac
 524
 525# If the branch to rebase is given, that is the branch we will rebase
 526# $branch_name -- branch/commit being rebased, or HEAD (already detached)
 527# $orig_head -- commit object name of tip of the branch before rebasing
 528# $head_name -- refs/heads/<that-branch> or "detached HEAD"
 529switch_to=
 530case "$#" in
 5311)
 532        # Is it "rebase other $branchname" or "rebase other $commit"?
 533        branch_name="$1"
 534        switch_to="$1"
 535
 536        # Is it a local branch?
 537        if git show-ref --verify --quiet -- "refs/heads/$branch_name" &&
 538           orig_head=$(git rev-parse -q --verify "refs/heads/$branch_name")
 539        then
 540                head_name="refs/heads/$branch_name"
 541        # If not is it a valid ref (branch or commit)?
 542        elif orig_head=$(git rev-parse -q --verify "$branch_name")
 543        then
 544                head_name="detached HEAD"
 545
 546        else
 547                die "$(eval_gettext "fatal: no such branch/commit '\$branch_name'")"
 548        fi
 549        ;;
 5500)
 551        # Do not need to switch branches, we are already on it.
 552        if branch_name=$(git symbolic-ref -q HEAD)
 553        then
 554                head_name=$branch_name
 555                branch_name=$(expr "z$branch_name" : 'zrefs/heads/\(.*\)')
 556        else
 557                head_name="detached HEAD"
 558                branch_name=HEAD
 559        fi
 560        orig_head=$(git rev-parse --verify HEAD) || exit
 561        ;;
 562*)
 563        die "BUG: unexpected number of arguments left to parse"
 564        ;;
 565esac
 566
 567if test "$fork_point" = t
 568then
 569        new_upstream=$(git merge-base --fork-point "$upstream_name" \
 570                        "${switch_to:-HEAD}")
 571        if test -n "$new_upstream"
 572        then
 573                restrict_revision=$new_upstream
 574        fi
 575fi
 576
 577if test "$autostash" = true && ! (require_clean_work_tree) 2>/dev/null
 578then
 579        stash_sha1=$(git stash create "autostash") ||
 580        die "$(gettext 'Cannot autostash')"
 581
 582        mkdir -p "$state_dir" &&
 583        echo $stash_sha1 >"$state_dir/autostash" &&
 584        stash_abbrev=$(git rev-parse --short $stash_sha1) &&
 585        echo "$(eval_gettext 'Created autostash: $stash_abbrev')" &&
 586        git reset --hard
 587fi
 588
 589require_clean_work_tree "rebase" "$(gettext "Please commit or stash them.")"
 590
 591# Now we are rebasing commits $upstream..$orig_head (or with --root,
 592# everything leading up to $orig_head) on top of $onto
 593
 594# Check if we are already based on $onto with linear history,
 595# but this should be done only when upstream and onto are the same
 596# and if this is not an interactive rebase.
 597mb=$(git merge-base "$onto" "$orig_head")
 598if test "$type" != interactive && test "$upstream" = "$onto" &&
 599        test "$mb" = "$onto" && test -z "$restrict_revision" &&
 600        # linear history?
 601        ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
 602then
 603        if test -z "$force_rebase"
 604        then
 605                # Lazily switch to the target branch if needed...
 606                test -z "$switch_to" ||
 607                GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to" \
 608                        git checkout -q "$switch_to" --
 609                if test "$branch_name" = "HEAD" &&
 610                         ! git symbolic-ref -q HEAD
 611                then
 612                        say "$(eval_gettext "HEAD is up to date.")"
 613                else
 614                        say "$(eval_gettext "Current branch \$branch_name is up to date.")"
 615                fi
 616                finish_rebase
 617                exit 0
 618        else
 619                if test "$branch_name" = "HEAD" &&
 620                         ! git symbolic-ref -q HEAD
 621                then
 622                        say "$(eval_gettext "HEAD is up to date, rebase forced.")"
 623                else
 624                        say "$(eval_gettext "Current branch \$branch_name is up to date, rebase forced.")"
 625                fi
 626        fi
 627fi
 628
 629# If a hook exists, give it a chance to interrupt
 630run_pre_rebase_hook "$upstream_arg" "$@"
 631
 632if test -n "$diffstat"
 633then
 634        if test -n "$verbose"
 635        then
 636                echo "$(eval_gettext "Changes from \$mb to \$onto:")"
 637        fi
 638        # We want color (if set), but no pager
 639        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 640fi
 641
 642test "$type" = interactive && run_specific_rebase
 643
 644# Detach HEAD and reset the tree
 645say "$(gettext "First, rewinding head to replay your work on top of it...")"
 646
 647GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name" \
 648        git checkout -q "$onto^0" || die "could not detach HEAD"
 649git update-ref ORIG_HEAD $orig_head
 650
 651# If the $onto is a proper descendant of the tip of the branch, then
 652# we just fast-forwarded.
 653if test "$mb" = "$orig_head"
 654then
 655        say "$(eval_gettext "Fast-forwarded \$branch_name to \$onto_name.")"
 656        move_to_original_branch
 657        finish_rebase
 658        exit 0
 659fi
 660
 661if test -n "$rebase_root"
 662then
 663        revisions="$onto..$orig_head"
 664else
 665        revisions="${restrict_revision-$upstream}..$orig_head"
 666fi
 667
 668run_specific_rebase